"""etiket_client_v_0.1.3

Revision ID: 716ce37a1bc1
Revises: 6e8777d1c9f3
Create Date: 2023-12-18 20:58:00.325404

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '716ce37a1bc1'
down_revision: Union[str, None] = '6e8777d1c9f3'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('core_tools_sync_data')
    op.create_table('core_tools_sync_data',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('database_id', sa.String(), nullable=False),
    sa.Column('core_tools_id', sa.Integer(), nullable=False),
    sa.Column('collected', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('database_id', 'core_tools_id', name='core_tools_id_constraint')
    )
    op.add_column('core_tools_sync_data', sa.Column('core_tools_project', sa.String(), nullable=False))
    op.add_column('core_tools_sync_data', sa.Column('synchronized', sa.Boolean(), nullable=False))
    op.add_column('core_tools_sync_data', sa.Column('failed', sa.Boolean(), nullable=False))
    op.create_index('failed_upload_index', 'core_tools_sync_data', ['database_id', 'failed'], unique=False)
    op.create_index(op.f('ix_core_tools_sync_data_core_tools_id'), 'core_tools_sync_data', ['core_tools_id'], unique=False)
    op.create_index('read_item_index', 'core_tools_sync_data', ['database_id', 'core_tools_project', 'synchronized', 'core_tools_id'], unique=False)
    op.create_index('sync_upload_index', 'core_tools_sync_data', ['database_id', 'synchronized'], unique=False)
    
    op.add_column('sync_sources', sa.Column('items_failed', sa.Integer(), nullable=True))
    op.execute("UPDATE sync_sources SET items_failed = 0;")

    op.add_column('sync_sources', sa.Column('items_skipped', sa.Integer(), nullable=True))
    op.execute("UPDATE sync_sources SET items_skipped = 0;")

    # copy table as constraints cannot be altered in sqlite -- make non-nullable
    op.create_table('sync_sources_temp',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('native', 'coretools', 'qcodes', 'quantify', name='syncsourcetypes'), nullable=False),
    sa.Column('status', sa.Enum('synchronized', 'synchronizing', 'pending', name='syncsourcestatus'), nullable=False),
    sa.Column('items_synchronized', sa.Integer(), nullable=False),
    sa.Column('items_total', sa.Integer(), nullable=False),
    sa.Column('last_update', sa.DateTime(), nullable=False),
    sa.Column('config_data', sa.JSON(), nullable=False),
    sa.Column('items_failed', sa.Integer(), nullable=False),
    sa.Column('items_skipped', sa.Integer(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.execute("INSERT INTO sync_sources_temp SELECT * FROM sync_sources")
    op.drop_table('sync_sources')
    op.execute("ALTER TABLE sync_sources_temp RENAME TO sync_sources;")
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('sync_sources', 'items_skipped')
    op.drop_column('sync_sources', 'items_failed')
    op.drop_index('sync_upload_index', table_name='core_tools_sync_data')
    op.drop_index('read_item_index', table_name='core_tools_sync_data')
    op.drop_index(op.f('ix_core_tools_sync_data_core_tools_id'), table_name='core_tools_sync_data')
    op.drop_index('failed_upload_index', table_name='core_tools_sync_data')
    op.drop_column('core_tools_sync_data', 'failed')
    op.drop_column('core_tools_sync_data', 'synchronized')
    op.drop_column('core_tools_sync_data', 'core_tools_project')
    # ### end Alembic commands ###
