"""adding sync attr to files

Revision ID: c077798e06b9
Revises: 24b0115d4cc7
Create Date: 2024-05-03 11:58:59.493407

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa
from sqlalchemy import inspect



# revision identifiers, used by Alembic.
revision: str = 'c077798e06b9'
down_revision: Union[str, None] = '24b0115d4cc7'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    if not has_column('files', 'synchronized'):
        op.add_column('files', sa.Column('synchronized', sa.Boolean(), nullable=False, server_default="0"))
    op.create_index(op.f('files_sync_index'), 'files', ['synchronized'], unique=False)

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('files_sync_index'), table_name='files')
    op.drop_column('files', 'synchronized')
    # ### end Alembic commands ###

def has_column(table_name, column_name):
    bind = op.get_context().bind
    insp = inspect(bind)
    columns = insp.get_columns(table_name)
    return any(c["name"] == column_name for c in columns)