"""etiket_client_v0.1.5

Revision ID: c5d93c68feda
Revises: 716ce37a1bc1
Create Date: 2024-01-12 10:07:40.238683

"""
from typing import Sequence, Union

from alembic import op
from datetime import datetime
import sqlalchemy as sa



# revision identifiers, used by Alembic.
revision: str = 'c5d93c68feda'
down_revision: Union[str, None] = '716ce37a1bc1'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('core_tools_sync_data', sa.Column('last_update', sa.DateTime(), nullable=False, server_default=str(datetime.now())))
    op.drop_index('sync_upload_index', table_name='core_tools_sync_data')
    op.create_index('sync_upload_index', 'core_tools_sync_data', ['database_id', 'failed', 'synchronized'], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('sync_upload_index', table_name='core_tools_sync_data')
    op.create_index('sync_upload_index', 'core_tools_sync_data', ['database_id', 'synchronized'], unique=False)
    op.drop_column('core_tools_sync_data', 'last_update')
    # ### end Alembic commands ###
