"""add app register table

Revision ID: f8337520d10d
Revises: 4b200763b2ff
Create Date: 2024-05-29 09:12:16.337553

"""
from typing import Sequence, Union
from sqlalchemy.engine.reflection import Inspector

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = 'f8337520d10d'
down_revision: Union[str, None] = '4b200763b2ff'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    conn = op.get_bind()
    inspector = Inspector.from_engine(conn)
    tables = inspector.get_table_names()
    if 'qharbor_app_register' not in tables:
        op.create_table('qharbor_app_register',
            sa.Column('id', sa.Integer(), nullable=False),
            sa.Column('type', sa.Enum('qDrive', 'etiket_client', 'dataQruiser', name='proctypes'), nullable=False),
            sa.Column('version', sa.String(), nullable=False),
            sa.Column('location', sa.String(), nullable=False),
            sa.Column('last_session', sa.DateTime(timezone=True), nullable=False),
            sa.PrimaryKeyConstraint('id')
        )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('qharbor_app_register')
    # ### end Alembic commands ###
